// ********************************************************************************
// utility actionscript: spacebox tracking logic
// mathias ochsendorf  : ochsendorf@hbt.arch.ethz.ch
//
// january 2005
// ********************************************************************************

// read the standard logic actionscript:
#include "spacebox_logic.as"

// areas
_global.area1;
_global.area2;
_global.area3;
_global.area4;
_global.area5;
_global.area6;
_global.area7;
_global.area8;
_global.area9;


// stores the nine areas; each area is defined within an Object with id parameter
// and taken parameter:
// ********************************************************************************
_root.myArea = new Array();

_root.definedAreaX = new Array();
_root.definedAreaY = new Array();

// this array stores the current occupancy of the 9 areas:
// ********************************************************************************
_root.isMyAreaTaken = new Array();

initAreas();


// public  methods
// ---------------
//
// check if a area is taken or not
// ********************************************************************************
MovieClip.prototype.isAreaTaken = function(areaID){
	trace("isAreaTaken:" + areaID);
	return _root.isMyAreaTaken[areaID];
}



// init the 9 areas
// ********************************************************************************
function initAreas(){
	for (i = 1; i<10; i++){
		setArea(i);
		_root.myArea[i] = new Object();
		_root.myArea[i].id = "ID:" + i;
		_root.myArea[i].taken = 0;
		_root.isMyAreaTaken[i] = false;
	}
	_root.definedAreaX[1] = 10;
	_root.definedAreaY[1] = 10;
	_root.definedAreaX[2] = 350;
	_root.definedAreaY[2] = 10;
	_root.definedAreaX[3] = 500;
	_root.definedAreaY[3] = 10;

	_root.definedAreaX[4] = 10;
	_root.definedAreaY[4] = 250;
	_root.definedAreaX[5] = 350;
	_root.definedAreaY[5] = 250;
	_root.definedAreaX[6] = 500;
	_root.definedAreaY[6] = 250;


	_root.definedAreaX[7] = 10;
	_root.definedAreaY[7] = 400;
	_root.definedAreaX[8] = 350;
	_root.definedAreaY[8] = 400;
	_root.definedAreaX[9] = 500;
	_root.definedAreaY[9] = 400;
}
// set area
function setArea(index){
	trace("myIndex in setArea: " + index);
	area = eval("area"+index);
	area.id = "ID:" + index;
	area.taken = 0;
	area._alpha = 20;
}


// react on server responses
// ********************************************************************************
// a message from the server received
function onSockMessage(xml_response) {
	trace("onSockMessage:"+xml_response);
    processResponse(xml_response);
}

function processResponse(node){
	if(node.nodeName == osgiPrefix + "trackingSimple"
	|| node.nodeName == osgiPrefix + "message"
	|| node.nodeName == osgiPrefix + "rcbox" )
	{
		traverse_XML_message(node);
		trace("bodycount: " + bodyCount);
		if(bodyCount != undefined){
			processTrackingInfo();
			bodyCount =undefined;
		}
		return;
	}
	if(!node.hasChildNodes()) return;
	var n = node.firstChild;
	do{processResponse(n);} while(n = n.nextSibling);
}

// process tracking information
// ********************************************************************************
function processTrackingInfo(){
	for (var i:Number = 1; i<10; i++) {
		area  = eval("area"+i);
		trace("processTrackingInfo: " + area.id + ":" + area.taken);
		// if area.taken is 1 a person stands in that area,
		// if the area == 0 the area is empty
		// ==============================================
		// add functionality here
		// ==============================================
	}
}

// parse through a xml message
// ********************************************************************************
function traverse_XML_message(node){
  	if(!node.hasChildNodes()) return;
    if(node.nodeName == osgiPrefix + "bodycount"){
    	bodyCount = String(node.firstChild.nodeValue);
    }
    if(node.nodeName == osgiPrefix + "area"){
    	updateArea(node);
    }

    // recursion:
    var n = node.firstChild;
    do{traverse_XML_message(n);} while(n = n.nextSibling);
}

// update area
// ********************************************************************************
function updateArea(node){
  	if(!node.hasChildNodes()) return;
	if(node.nodeName == osgiPrefix + "id") areaID = String(node.firstChild.nodeValue);
	else if(node.nodeName == osgiPrefix + "taken") {
		areaTaken = String(node.firstChild.nodeValue);
		trace("updateArea"+ areaID+" taken:" +areaTaken);
		eval("area"+areaID).taken = areaTaken;
		eval("area"+areaID)._alpha = 20 + 80*areaTaken;

		//**** update des Arrays 'myArea' *******************
		_root.myArea[areaID].taken = areaTaken;

		//**** update des alternatioven Abfrage.. *******************
		if(areaTaken == 0){
			_root.isMyAreaTaken[areaID] = false;
		}
		if(areaTaken == 1){
			_root.isMyAreaTaken[areaID] = true;
		}
	}
	// recursion:
	var n = node.firstChild;
    do{updateArea(n);} while(n = n.nextSibling);

}

// simulate the broadcasting of information containing data of tracked persons
// ********************************************************************************
MovieClip.prototype.trackingSimulation = function(number){
	trace("trackingSimulation number: " + number);
	if(number == isNAN){
		return;
	}
	trace("trackingSimulation number:" + number);
	message = "<spacebox><tracking>";
	message += "<bodycount>" + number + "</bodycount>";
	for (i = 0; i<number; i++) {
		randomX = Math.round(Math.random() * 640 * 0.7);
		randomY = Math.round(Math.random() * 480 * 0.7);
		randomW = 100 + Math.round(Math.random() * 100);
		randomH = 100 + Math.round(Math.random() * 100);
		message += "<body><id>" + i + "</id>";
		message += "<x>"+ randomX +"</x>";
		message += "<y>"+ randomY +"</y>";
		message += "<width>"+ randomW +"</width>";
		message += "<height>"+ randomH +"</height>";
		message += "</body>";
	}
	message += "</tracking></spacebox>";
	trace("trackingSimulation send:" + message);
	sockOsgi.send(message);
}
// ********************************************************************************
MovieClip.prototype.simulateTrackingArea = function(areaID){
	trace("simulateTrackingArea number: " + areaID);
	if(areaID == isNAN){
		return;
	}
	var message:String = String("<spacebox><tracking>");
	message += "<bodycount>1</bodycount>";
	randomW = 100 + Math.round(Math.random() * 100);
	randomH = 100 + Math.round(Math.random() * 100);
	message += "<body><id>" + i + "</id>";
	message += "<x>"+ definedAreaX[areaID] +"</x>";
	message += "<y>"+ definedAreaY[areaID] +"</y>";
	message += "<width>"+ randomW +"</width>";
	message += "<height>"+ randomH +"</height>";
	message += "</body>";
	message += "</tracking></spacebox>";
	trace("simulateTrackingArea send:" + message);
	sockOsgi.send(message);
}
// end*****************************************************************************end

